<?php
namespace Services;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DependencyInjection\InstanceManager;
use Zeedhi\Framework\Util\QuerySelector;

class Mym00110InformativoService {

	protected $connection;
	protected $environment;
	protected $customerID;
	
	public function __construct($connection, $environment, $customerID){
        $this->connection = $connection;
        $this->environment = $environment;
        $this->customerID = $customerID;
	}

    public function getTopicNamesToPush($CDFILIAL, $NRLOCALPESQ){
        $connection = InstanceManager::getInstance()->getService('entityManager')->getConnection();
        
        $filterNrlocalPesq = '';
            if (!empty($NRLOCALPESQ)){
                    $filterNrlocalPesq = <<<SQL
                    AND NRLOCALPESQ = :NRLOCALPESQ
SQL;
            }
        
        $queryOracle = <<<SQL
            SELECT NRQRCODELOCALPESQ 
            FROM QRCODELOCALPESQ 
            WHERE CDFILIAL = :CDFILIAL AND (NRLOCALPESQ = :NRLOCALPESQ OR :NRLOCALPESQ IS NULL) AND SYSDATE <= NVL(DTEXPIRACAO,SYSDATE)
SQL;

        $queryPostgre = <<<SQL
            SELECT NRQRCODELOCALPESQ 
            FROM QRCODELOCALPESQ 
            WHERE CDFILIAL = :CDFILIAL $filterNrlocalPesq AND current_timestamp <= COALESCE(DTEXPIRACAO, current_timestamp)
SQL;
        
        $params = array(
            'CDFILIAL' => $CDFILIAL,
            'NRLOCALPESQ' => $NRLOCALPESQ
        );
        
        $arrayQueries = array (
            'default'   => $queryOracle,
            'pdo_pgsql' => $queryPostgre
        );
        
        $params = array(
            "CDFILIAL" => $CDFILIAL,
            "NRLOCALPESQ" => $NRLOCALPESQ
        );
        
        $query = QuerySelector::getQueryByDriver($connection, $arrayQueries);
        // $stmt = $this->connection->prepare($query);
        // $qrCodeIDS = $stmt->fetchAll($query, $params);
        // $qrCodeIDS = $connection->fetchAll($query, $params);
        $qrCodeIDS = $connection->fetchAll($query, $params);

        $this->NRORG = $this->environment->getNrOrg();
        
        $concatNrorgAndCustomerID = function($sqlResultRow){
            
            if(isset($sqlResultRow['nrqrcodelocalpesq'])){
                return $this->customerID . "_" . $this->NRORG . "_" . $sqlResultRow['nrqrcodelocalpesq'];
            }else{
                return $this->customerID . "_" . $this->NRORG . "_" . $sqlResultRow['NRQRCODELOCALPESQ'];
            }
        };
        
        return array_map($concatNrorgAndCustomerID, $qrCodeIDS);
    }
    
    public function getDatasExpiradasToPush($CDFILIAL, $NRLOCALPESQ){
        $connection = InstanceManager::getInstance()->getService('entityManager')->getConnection();
        
                $filterNrlocalPesq = '';
            if (!empty($NRLOCALPESQ)){
                    $filterNrlocalPesq = <<<SQL
                    AND QR.NRLOCALPESQ = :NRLOCALPESQ
SQL;
        }
        
        $queryOracle = <<<SQL
            SELECT QR.NRQRCODELOCALPESQ, 
                TO_CHAR(QR.DTEXPIRACAO) AS DTEXPIRACAO, 
                QR.CDFILIAL, 
                F.NMFILIAL, 
                L.NMLOCALPESQ 
            FROM QRCODELOCALPESQ QR INNER JOIN FILIAL F ON F.NRORG = QR.NRORG AND F.CDFILIAL = QR.CDFILIAL 
                LEFT JOIN LOCALPESQ L ON L.NRORG =  QR.NRORG AND L.NRLOCALPESQ = QR.NRLOCALPESQ 
            WHERE QR.CDFILIAL = :CDFILIAL AND SYSDATE > QR.DTEXPIRACAO 
            ORDER BY QR.CDFILIAL, L.NMLOCALPESQ
SQL;

        $queryPostgre = <<<SQL
            SELECT QR.NRQRCODELOCALPESQ, 
                TO_DATE('QR.DTEXPIRACAO', 'DD YYYY Mon') AS DTEXPIRACAO, 
                QR.CDFILIAL, 
                F.NMFILIAL, 
                L.NMLOCALPESQ 
            FROM QRCODELOCALPESQ QR INNER JOIN FILIAL F ON F.NRORG = QR.NRORG AND F.CDFILIAL = QR.CDFILIAL 
                LEFT JOIN LOCALPESQ L ON L.NRORG =  QR.NRORG AND L.NRLOCALPESQ = QR.NRLOCALPESQ  
            WHERE QR.CDFILIAL = :CDFILIAL $filterNrlocalPesq AND current_timestamp > QR.DTEXPIRACAO 
            ORDER BY QR.CDFILIAL, L.NMLOCALPESQ
SQL;

        $params = array(
            "CDFILIAL"      => $CDFILIAL,
            "NRLOCALPESQ"   => $NRLOCALPESQ
        );
        
        $arrayQueries = array (
            'default'   => $queryOracle,
            'pdo_pgsql' => $queryPostgre
        );
        
        $query = QuerySelector::getQueryByDriver($connection, $arrayQueries);
        
        
        $qrCodeIDS = $connection->fetchAll($query, $params);

        $this->NRORG = $this->environment->getNrOrg();
        
        $concatString = function($sqlResultRow){
            
            return $sqlResultRow['DTEXPIRACAO'] . "_" . $sqlResultRow['NRQRCODELOCALPESQ'];
        };
        
        return $qrCodeIDS;
        
    }

}