<?php
/**
 * GepOpersituacaoLogic.
 *
 * @package Logic
 * @author  daniellepereira <username@example.com>
 */
class GepOpersituacaoLogic {


    /**
    * Gera novo c?digo de Operador respons?vel na Situa??o por Tipo de Fluxo.
    *
    * @param integer $nrorg N?mero da Organiza??o.
    *
    * @return $codigo integer
    */
    public static function retornaProxNumeroOperSituacao($nrorg){
        $codigo = GepOpersituacaoEntity::retornaProxNumeroOperSituacao($nrorg);
        return $codigo;
    }


    /**
     * Retorna dados de um operador responsavel atraves da situacao.
     *
     * @throws Exception             Consulta sem registro.
     * @param  integer $nrorg        Numero da organizacao.
     * @param  integer $nrsituacao   Numero da situacao.
     *
     * @return object|bool
     */
    public static function retornaOperadorResponsavel($nrorg, $nrsituacao){
        try{
            $dados = GepOpersituacaoEntity::retornaOperadorResponsavel($nrorg, $nrsituacao);
            return $dados;
        } catch (Exception $e) {
            switch ($e->getCode()){
                case GepOpersituacaoEntity::SEM_REGISTRO:
                    return GepOpersituacaoEntity::SEM_REGISTRO;
                default:
                    tk_message('Erro desconhecido', $e->getMessage());
                    return false;
            }
        }
    }


}