/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TPINDICADOR                                              */
/* Tabela : TPINDICADOR                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 01/03/2007 - Rejane P. Leite                                               */
/*                                                                            */
/******************************************************************************/
CREATE OR REPLACE TRIGGER DTULTATU_TPINDICADOR
BEFORE INSERT OR UPDATE OR DELETE
ON TPINDICADOR FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTPIN := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDTPINDICA,0 ) <> NVL(:NEW.CDTPINDICA,0)) OR
         (NVL(:OLD.DSTPINDICA,0 ) <> NVL(:NEW.DSTPINDICA,0)) OR
         (NVL(:OLD.DSFONTEIND,0 ) <> NVL(:NEW.DSFONTEIND,0)) OR
         (NVL(:OLD.DSPADACAOTPI,0 ) <> NVL(:NEW.DSPADACAOTPI,0)) THEN
         :NEW.DTULTATUTPIN := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TPINDICADOR', '','CDTPINDICA='||:OLD.CDTPINDICA||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TPINDICADOR MODIFY DTULTATUTPIN DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_TPINDICADOR','5.03.010'); END;
/

