<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;


class FpaRegram extends \Doctrine\ORM\EntityRepository {
    
    public function retornaRegras($nrOrg, $nrOrgPadrao, $dtCompetencia){
	
    $fpaRegram =  'Teknisa\Model\Gestaopessoas\Entities\FpaRegram';
    $fpaRegrah =  'Teknisa\Model\Gestaopessoas\Entities\FpaRegrah';

$sql = <<<SQL
    SELECT rm, rh
    FROM $fpaRegram rm
    INNER JOIN $fpaRegrah rh WITH 
            rm.nrregram = rh.nrregram
            AND rh.dtmescompetenc = ( SELECT MAX(rhh.dtmescompetenc) FROM $fpaRegrah rhh
                                     WHERE rhh.dtmescompetenc <= :p_dtmescompetenc
                                       AND rhh.nrregram = rh.nrregram )
            WHERE
            rm.nrorg = :p_nrorg or rm.nrorg = :p_nrorg_padrao
            ORDER BY rm.nrregram                                               
SQL;
            $params = array(
                'p_dtmescompetenc' => $dtCompetencia,
                'p_nrorg' => $nrOrg,
                'p_nrorg_padrao' => $nrOrgPadrao
            );
            
            $resultQuery = $this->getEntityManager()->createQuery($sql)->execute($params);
            
            $resultado = array();
            foreach ($resultQuery as $key => $regra) {
                if($regra instanceof $fpaRegram){
                    $regra->historico = $resultQuery[$key+1];
                    $resultado[] = $regra;
                }    
            }
            return $resultado;
    }
    
}